#!/bin/sh
echo '# generating map...'

./bin/x64/factorio \
    --create map-gen.zip \
    --map-gen-settings map-gen.json \
    > /dev/null 2> /dev/null

echo '# starting server...'

./bin/x64/factorio \
    --start-server map-gen.zip \
    --port 34297 \
    --no-auto-pause \
    --server-settings map-gen.server.json \
    --latency 1 \
    --autosave-interval 0 \
    > map-gen.log 2>&1 &

PID=$!;

LAST=x
while ! fgrep -q Screenshot map-gen.log; do
    if [ -d /proc/$PID ]; then
        if fgrep -v "Reading stdin failed" map-gen.log | fgrep -q Error; then
            kill -KILL $PID
            sleep 1
            echo "An errror occured while generating the map…" 1>&2
            cat map-gen.log 1>&2
            exit 1
        fi

        LINE=`fgrep "generat" map-gen.log | tail -n 1`
        if [ "yx$LINE" != "y$LAST" ]; then
            printf "%s\n" "$LINE"
            LAST="x$LINE"
        fi

        sleep 1
    else
        echo "Factorio was killed..." >&2
        cat map-gen.log >&2
        exit 1
    fi
done

FILE=./script-output/"`sed -e '/Screenshot: / ! d; s/Screenshot: //' map-gen.log`"

while ! [ -e "$FILE" ]; do sleep 1; done

CHANGED=true
SIZE=x

while true; do
    OSIZE=$SIZE
    SIZE=x`stat -c %s "$FILE"`
    if [ y$SIZE = yx ]; then
        echo undefined size?
        sleep 1;
    elif [ y$OSIZE = y$SIZE ]; then
        break
    else
        sleep 1;
    fi
done

kill -9 $PID

# pnmtojpeg < "$FILE" > "${FILE%.ppm}.jpg"
# pnmtopng -compression 9 < "$FILE" > "${FILE%.ppm}.png"

echo "# map generated: $FILE"
